Package org.apache.commons.math3.distribution

# Class ParetoDistribution

java.lang.Object
org.apache.commons.math3.distribution.AbstractRealDistribution
org.apache.commons.math3.distribution.ParetoDistribution

All Implemented Interfaces:
  `Serializable`, `RealDistribution`

public class ParetoDistribution extends AbstractRealDistribution
Implementation of the Pareto distribution.

Parameters: The probability distribution function of `X` is given by (for `x >= k`):

      α * k^α / x^(α + 1)

- `k` is the scale parameter: this is the minimum possible value of `X`,
- `α` is the shape parameter: this is the Pareto index

Since:
  3.3
See Also:
  - Pareto distribution (Wikipedia)
  - Pareto distribution (MathWorld)
  - Serialized Form

## Field Summary

Fields
Modifier and Type
Field
Description
`static final double`
`DEFAULT_INVERSE_ABSOLUTE_ACCURACY`
Default inverse cumulative probability accuracy.

### Fields inherited from class org.apache.commons.math3.distribution.AbstractRealDistribution

`random, randomData, SOLVER_DEFAULT_ABSOLUTE_ACCURACY`

## Constructor Summary

Constructors
Constructor
Description
`ParetoDistribution()`
Create a Pareto distribution with a scale of `1` and a shape of `1`.
`ParetoDistribution(double scale, double shape)`
Create a Pareto distribution using the specified scale and shape.
`ParetoDistribution(double scale, double shape, double inverseCumAccuracy)`
Create a Pareto distribution using the specified scale, shape and inverse cumulative distribution accuracy.
`ParetoDistribution(RandomGenerator rng, double scale, double shape)`
Creates a Pareto distribution.
`ParetoDistribution(RandomGenerator rng, double scale, double shape, double inverseCumAccuracy)`
Creates a Pareto distribution.

## Method Summary

Modifier and Type
Method
Description
`double`
`cumulativeProbability(double x)`
For a random variable `X` whose values are distributed according to this distribution, this method returns `P(X <= x)`.
`double`
`cumulativeProbability(double x0, double x1)`
Deprecated.
See `RealDistribution.cumulativeProbability(double,double)`
`double`
`density(double x)`
Returns the probability density function (PDF) of this distribution evaluated at the specified point `x`.
`double`
`getNumericalMean()`
Use this method to get the numerical value of the mean of this distribution.
`double`
`getNumericalVariance()`
Use this method to get the numerical value of the variance of this distribution.
`double`
`getScale()`
Returns the scale parameter of this distribution.
`double`
`getShape()`
Returns the shape parameter of this distribution.
`protected double`
`getSolverAbsoluteAccuracy()`
Returns the solver absolute accuracy for inverse cumulative computation.
`double`
`getSupportLowerBound()`
Access the lower bound of the support.
`double`
`getSupportUpperBound()`
Access the upper bound of the support.
`boolean`
`isSupportConnected()`
Use this method to get information about whether the support is connected, i.e.
`boolean`
`isSupportLowerBoundInclusive()`
Whether or not the lower bound of support is in the domain of the density function.
`boolean`
`isSupportUpperBoundInclusive()`
Whether or not the upper bound of support is in the domain of the density function.
`double`
`logDensity(double x)`
Returns the natural logarithm of the probability density function (PDF) of this distribution evaluated at the specified point `x`.
`double`
`sample()`
Generate a random value sampled from this distribution.

### Methods inherited from class org.apache.commons.math3.distribution.AbstractRealDistribution

`inverseCumulativeProbability, probability, probability, reseedRandomGenerator, sample`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### DEFAULT_INVERSE_ABSOLUTE_ACCURACY

public static final double DEFAULT_INVERSE_ABSOLUTE_ACCURACY
Default inverse cumulative probability accuracy.

See Also:
  - Constant Field Values

## Constructor Details

### ParetoDistribution

public ParetoDistribution()
Create a Pareto distribution with a scale of `1` and a shape of `1`.

### ParetoDistribution

public ParetoDistribution(double scale, double shape) throws NotStrictlyPositiveException
Create a Pareto distribution using the specified scale and shape.

Note: this constructor will implicitly create an instance of `Well19937c` as random generator to be used for sampling only (see `sample()` and `AbstractRealDistribution.sample(int)`). In case no sampling is needed for the created distribution, it is advised to pass `null` as random generator via the appropriate constructors to avoid the additional initialisation overhead.

Parameters:
  `scale` - the scale parameter of this distribution
  `shape` - the shape parameter of this distribution
Throws:
  `NotStrictlyPositiveException` - if `scale <= 0` or `shape <= 0`.

### ParetoDistribution

public ParetoDistribution(double scale, double shape, double inverseCumAccuracy) throws NotStrictlyPositiveException
Create a Pareto distribution using the specified scale, shape and inverse cumulative distribution accuracy.

Note: this constructor will implicitly create an instance of `Well19937c` as random generator to be used for sampling only (see `sample()` and `AbstractRealDistribution.sample(int)`). In case no sampling is needed for the created distribution, it is advised to pass `null` as random generator via the appropriate constructors to avoid the additional initialisation overhead.

Parameters:
  `scale` - the scale parameter of this distribution
  `shape` - the shape parameter of this distribution
  `inverseCumAccuracy` - Inverse cumulative probability accuracy.
Throws:
  `NotStrictlyPositiveException` - if `scale <= 0` or `shape <= 0`.

### ParetoDistribution

public ParetoDistribution(RandomGenerator rng, double scale, double shape) throws NotStrictlyPositiveException
Creates a Pareto distribution.

Parameters:
  `rng` - Random number generator.
  `scale` - Scale parameter of this distribution.
  `shape` - Shape parameter of this distribution.
Throws:
  `NotStrictlyPositiveException` - if `scale <= 0` or `shape <= 0`.

### ParetoDistribution

public ParetoDistribution(RandomGenerator rng, double scale, double shape, double inverseCumAccuracy) throws NotStrictlyPositiveException
Creates a Pareto distribution.

Parameters:
  `rng` - Random number generator.
  `scale` - Scale parameter of this distribution.
  `shape` - Shape parameter of this distribution.
  `inverseCumAccuracy` - Inverse cumulative probability accuracy.
Throws:
  `NotStrictlyPositiveException` - if `scale <= 0` or `shape <= 0`.

## Method Details

### getScale

public double getScale()
Returns the scale parameter of this distribution.

Returns:
  the scale parameter

### getShape

public double getShape()
Returns the shape parameter of this distribution.

Returns:
  the shape parameter

### density

public double density(double x)
Returns the probability density function (PDF) of this distribution evaluated at the specified point `x`. In general, the PDF is the derivative of the `CDF`. If the derivative does not exist at `x`, then an appropriate replacement should be returned, e.g. `Double.POSITIVE_INFINITY`, `Double.NaN`, or the limit inferior or limit superior of the difference quotient.

For scale `k`, and shape `α` of this distribution, the PDF is given by

- `0` if `x < k`,
- `α * k^α / x^(α + 1)` otherwise.

Parameters:
  `x` - the point at which the PDF is evaluated
Returns:
  the value of the probability density function at point `x`

### logDensity

public double logDensity(double x)
Returns the natural logarithm of the probability density function (PDF) of this distribution evaluated at the specified point `x`. In general, the PDF is the derivative of the `CDF`. If the derivative does not exist at `x`, then an appropriate replacement should be returned, e.g. `Double.POSITIVE_INFINITY`, `Double.NaN`, or the limit inferior or limit superior of the difference quotient. Note that due to the floating point precision and under/overflow issues, this method will for some distributions be more precise and faster than computing the logarithm of `RealDistribution.density(double)`. The default implementation simply computes the logarithm of `density(x)`. See documentation of `density(double)` for computation details.

Overrides:
  `logDensity` in class `AbstractRealDistribution`
Parameters:
  `x` - the point at which the PDF is evaluated
Returns:
  the logarithm of the value of the probability density function at point `x`

### cumulativeProbability

public double cumulativeProbability(double x)
For a random variable `X` whose values are distributed according to this distribution, this method returns `P(X <= x)`. In other words, this method represents the (cumulative) distribution function (CDF) for this distribution.

For scale `k`, and shape `α` of this distribution, the CDF is given by

- `0` if `x < k`,
- `1 - (k / x)^α` otherwise.

Parameters:
  `x` - the point at which the CDF is evaluated
Returns:
  the probability that a random variable with this distribution takes a value less than or equal to `x`

### cumulativeProbability

@Deprecated public double cumulativeProbability(double x0, double x1) throws NumberIsTooLargeException
Deprecated.
See `RealDistribution.cumulativeProbability(double,double)`
For a random variable `X` whose values are distributed according to this distribution, this method returns `P(x0 < X <= x1)`. The default implementation uses the identity

`P(x0 < X <= x1) = P(X <= x1) - P(X <= x0)`

Specified by:
  `cumulativeProbability` in interface `RealDistribution`
Overrides:
  `cumulativeProbability` in class `AbstractRealDistribution`
Parameters:
  `x0` - the exclusive lower bound
  `x1` - the inclusive upper bound
Returns:
  the probability that a random variable with this distribution takes a value between `x0` and `x1`, excluding the lower and including the upper endpoint
Throws:
  `NumberIsTooLargeException` - if `x0 > x1`

### getSolverAbsoluteAccuracy

protected double getSolverAbsoluteAccuracy()
Returns the solver absolute accuracy for inverse cumulative computation. You can override this method in order to use a Brent solver with an absolute accuracy different from the default.

Overrides:
  `getSolverAbsoluteAccuracy` in class `AbstractRealDistribution`
Returns:
  the maximum absolute error in inverse cumulative probability estimates

### getNumericalMean

public double getNumericalMean()
Use this method to get the numerical value of the mean of this distribution.

For scale `k` and shape `α`, the mean is given by

- `∞` if `α <= 1`,
- `α * k / (α - 1)` otherwise.

Returns:
  the mean or `Double.NaN` if it is not defined

### getNumericalVariance

public double getNumericalVariance()
Use this method to get the numerical value of the variance of this distribution.

For scale `k` and shape `α`, the variance is given by

- `∞` if `1 < α <= 2`,
- `k^2 * α / ((α - 1)^2 * (α - 2))` otherwise.

Returns:
  the variance (possibly `Double.POSITIVE_INFINITY` as for certain cases in `TDistribution`) or `Double.NaN` if it is not defined

### getSupportLowerBound

public double getSupportLowerBound()
Access the lower bound of the support. This method must return the same value as `inverseCumulativeProbability(0)`. In other words, this method must return

`inf {x in R | P(X invalid input: '<'= x) > 0}`.

The lower bound of the support is equal to the scale parameter `k`.

Returns:
  lower bound of the support

### getSupportUpperBound

public double getSupportUpperBound()
Access the upper bound of the support. This method must return the same value as `inverseCumulativeProbability(1)`. In other words, this method must return

`inf {x in R | P(X invalid input: '<'= x) = 1}`.

The upper bound of the support is always positive infinity no matter the parameters.

Returns:
  upper bound of the support (always `Double.POSITIVE_INFINITY`)

### isSupportLowerBoundInclusive

public boolean isSupportLowerBoundInclusive()
Whether or not the lower bound of support is in the domain of the density function. Returns true iff `getSupporLowerBound()` is finite and `density(getSupportLowerBound())` returns a non-NaN, non-infinite value.

Returns:
  true if the lower bound of support is finite and the density function returns a non-NaN, non-infinite value there

### isSupportUpperBoundInclusive

public boolean isSupportUpperBoundInclusive()
Whether or not the upper bound of support is in the domain of the density function. Returns true iff `getSupportUpperBound()` is finite and `density(getSupportUpperBound())` returns a non-NaN, non-infinite value.

Returns:
  true if the upper bound of support is finite and the density function returns a non-NaN, non-infinite value there

### isSupportConnected

public boolean isSupportConnected()
Use this method to get information about whether the support is connected, i.e. whether all values between the lower and upper bound of the support are included in the support.

The support of this distribution is connected.

Returns:
  `true`

### sample

public double sample()
Generate a random value sampled from this distribution. The default implementation uses the inversion method.

Specified by:
  `sample` in interface `RealDistribution`
Overrides:
  `sample` in class `AbstractRealDistribution`
Returns:
  a random value.